diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/ns3 ns-3.44/ns3
--- ns-3.43/ns3	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/ns3	2025-03-09 16:55:49.339371000 -0700
@@ -9,6 +9,7 @@
 import shutil
 import subprocess
 import sys
+import textwrap
 
 ns3_path = os.path.dirname(os.path.realpath(os.path.abspath(__file__)))
 append_to_ns3_path = functools.partial(os.path.join, ns3_path)
@@ -89,8 +90,11 @@
 
 
 def parse_args(argv):
+    py39args = {"exit_on_error": False}
+    if sys.version_info < (3, 9):
+        py39args = {}
     parser = argparse.ArgumentParser(
-        description="ns-3 wrapper for the CMake build system", add_help=False
+        description="ns-3 wrapper for the CMake build system", add_help=False, **py39args
     )
 
     sub_parser = parser.add_subparsers()
@@ -434,18 +438,28 @@
     parser_show = sub_parser.add_parser(
         "show", help='Try "./ns3 show --help" for more show options'
     )
-    parser_show.add_argument(
-        "show",
-        help=(
-            "Print the current ns-3 build profile type, configuration or version, "
-            "or a list of buildable/runnable targets"
-        ),
-        choices=["profile", "version", "config", "targets", "all"],
-        action="store",
-        type=str,
-        nargs="?",
-        default="all",
-    )
+    parser_show_sub = parser_show.add_subparsers(dest="show")
+
+    # Add subcommands for the "docs" command
+    # Since 'typeid' has a required arg, need to handle these
+    # with subparsers not simple "choices=[...]"
+    show_choices = ["profile", "version", "config", "targets", "typeid", "all"]
+
+    for choice in show_choices:
+        if choice == "typeid":
+            parser_typeid = parser_show_sub.add_parser(
+                "typeid",
+                help="Show the introspected documentation for a TypeId",
+            )
+            parser_typeid.add_argument(
+                "tid",
+                help='Show the introspected documentation for TypeId "tid"',
+                type=str,
+            )
+        else:
+            parser_show_sub.add_parser(choice)
+
+    parser_show.set_defaults(show="all")
 
     add_argument_to_subparsers(
         [
@@ -497,7 +511,17 @@
         runnable_args = []
 
     # Parse known arguments and separate from unknown arguments
-    args, unknown_args = parser.parse_known_args(ns3_args)
+    try:
+        args, unknown_args = parser.parse_known_args(ns3_args)
+    except argparse.ArgumentError as e:
+        error_message = e.message
+        custom_exits = ["invalid choice:"]
+        for custom_exit in custom_exits:
+            if custom_exit in e.message:
+                error_message = f"Exiting due to {e.message[e.message.index(custom_exit):]}"
+        # Format error message to better fit the terminal width
+        print("\n".join(textwrap.wrap(error_message, width=os.get_terminal_size().columns)))
+        exit(1)
 
     # If run doesn't have a target, print the help message of the run parser
     if "run" in args and args.run == "":
@@ -601,6 +625,7 @@
         "ENABLE_SUDO": False,
         "ENABLE_TESTS": False,
         "BUILD_VERSION_STRING": None,
+        "FETCH_NETANIM_VISUALIZER": False,
     }
     if output_directory and os.path.exists(lock_file):
         exec(open(lock_file).read(), globals(), build_info)
@@ -746,7 +771,12 @@
 
     if not current_cmake_generator:
         # Search for available generators
-        cmake_generator_map = {"ninja": "Ninja", "make": "Unix Makefiles", "xcodebuild": "Xcode"}
+        cmake_generator_map = {
+            "msbuild": "Visual Studio 17 2022",
+            "ninja": "Ninja",
+            "make": "Unix Makefiles",
+            "xcodebuild": "Xcode",
+        }
         available_generators = []
         for generator in cmake_generator_map.keys():
             if shutil.which(generator):
@@ -924,6 +954,8 @@
     # Try to set specified generator (will probably fail if there is an old cache)
     if args.G:
         cmake_args.extend(["-G", args.G])
+        if "Visual Studio" in args.G:
+            cmake_args.extend(["-A", "x64", "-T", "ClangCL"])
 
     if args.trace_cmake_perf:
         cmake_performance_trace = os.path.join(
@@ -976,6 +1008,9 @@
     ns3_program_map = {}
     longest_shortcut_map = {}
 
+    if programs_dict["FETCH_NETANIM_VISUALIZER"]:
+        ns3_program_map["netanim"] = [programs_dict["out_dir"] + "/bin/netanim"]
+
     for program in programs_dict["ns3_runnable_programs"]:
         if "pch_exec" in program:
             continue
@@ -1057,6 +1092,7 @@
 
 
 def parse_version(version_str):
+    version_str = version_str.split("-")[0]
     version = version_str.split(".")
     version = tuple(map(int, version))
     return version
@@ -1220,11 +1256,21 @@
     build_profile_suffix = "" if build_profile in ["release"] else "-" + build_profile
     program_name = ""
 
+    special_run_to_build_targets = {
+        "netanim": "netanim_visualizer",
+    }
+
     try:
         program_name = "".join(
             *re.findall("(.*)ns%s-(.*)%s" % (ns3_version, build_profile_suffix), program_path)
         )
     except TypeError:
+        # This is not your typical ns-3 executable.
+        # Maybe some imported target that had a conflicting name, like netanim
+        program_name = os.path.basename(program_path)
+        if program_name in special_run_to_build_targets:
+            return special_run_to_build_targets[program_name]
+        # Or maybe it is an error indeed
         print("Target to build does not exist: %s" % program_path)
         exit(1)
 
@@ -1755,6 +1801,16 @@
     if args.show == "version":
         show_build_version(build_version_string)
 
+    if args.show == "typeid":
+        sys.argv = [
+            "ns3",
+            "run",
+            "print-introspected-doxygen",
+            "--",
+            f"--TypeId={args.tid}",
+        ]
+        args = parse_args(sys.argv[1:])
+
     # Check if running something or reconfiguring ns-3
     run_only = False
     build_and_run = False
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/scratch/nested-subdir/lib/scratch-nested-subdir-library-header.h ns-3.44/scratch/nested-subdir/lib/scratch-nested-subdir-library-header.h
--- ns-3.43/scratch/nested-subdir/lib/scratch-nested-subdir-library-header.h	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/scratch/nested-subdir/lib/scratch-nested-subdir-library-header.h	2025-03-09 16:55:49.339371000 -0700
@@ -14,7 +14,7 @@
 /**
  * Get a message from the subdir.
  *
- * \return The message from the subdir
+ * @return The message from the subdir
  */
 std::string ScratchNestedSubdirGetMessage();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/scratch/subdir/scratch-subdir-additional-header.h ns-3.44/scratch/subdir/scratch-subdir-additional-header.h
--- ns-3.43/scratch/subdir/scratch-subdir-additional-header.h	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/scratch/subdir/scratch-subdir-additional-header.h	2025-03-09 16:55:49.339371000 -0700
@@ -14,7 +14,7 @@
 /**
  * Get a message from the subdir.
  *
- * \return The message from the subdir
+ * @return The message from the subdir
  */
 std::string ScratchSubdirGetMessage();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/CMakeLists.txt ns-3.44/src/antenna/CMakeLists.txt
--- ns-3.43/src/antenna/CMakeLists.txt	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/CMakeLists.txt	2025-03-09 16:55:49.339371000 -0700
@@ -74,6 +74,7 @@
     model/phased-array-model.h
     model/three-gpp-antenna-model.h
     model/uniform-planar-array.h
+    utils/symmetric-adjacency-matrix.h
   LIBRARIES_TO_LINK ${libcore}
   TEST_SOURCES
     ${circular_aperture_antenna_test_sources}
@@ -83,4 +84,5 @@
     test/test-isotropic-antenna.cc
     test/test-parabolic-antenna.cc
     test/test-uniform-planar-array.cc
+    test/test-adjacency-matrix.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/doc/Makefile ns-3.44/src/antenna/doc/Makefile
--- ns-3.43/src/antenna/doc/Makefile	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/doc/Makefile	2025-03-09 16:55:49.339371000 -0700
@@ -1,6 +1,6 @@
 EPSTOPDF = epstopdf
 DIA = dia
-CONVERT = convert
+CONVERT = convert -density 300
 
 SOURCE = source
 FIGURES = $(SOURCE)/figures
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/examples/adjacency-matrix-example.cc ns-3.44/src/antenna/examples/adjacency-matrix-example.cc
--- ns-3.43/src/antenna/examples/adjacency-matrix-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/antenna/examples/adjacency-matrix-example.cc	2025-03-09 16:55:49.343371000 -0700
@@ -0,0 +1,159 @@
+/*
+ * Copyright (c) 2025 CTTC
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+ */
+
+/**
+ * @file
+ * @ingroup antenna-examples
+ * Example program illustrating one application of symmetric adjacency matrices for routing
+ */
+
+#include "ns3/command-line.h"
+#include "ns3/symmetric-adjacency-matrix.h"
+
+#include <algorithm>
+#include <iostream>
+#include <limits>
+#include <map>
+
+int
+main(int argc, char** argv)
+{
+    char srcNodeOpt = 'A'; // 0
+    char dstNodeOpt = 'I'; // 8
+    ns3::CommandLine cmd(__FILE__);
+    cmd.AddValue("srcNode", "Source node [0-9]", srcNodeOpt);
+    cmd.AddValue("dstNode", "Destination node [0-9]", dstNodeOpt);
+    cmd.Parse(argc, argv);
+
+    NS_ABORT_MSG_IF(srcNodeOpt < 'A' || srcNodeOpt > 'J', "Invalid source node");
+    NS_ABORT_MSG_IF(dstNodeOpt < 'A' || dstNodeOpt > 'J', "Invalid destination node");
+
+    // -A(65) remove the skew from 0
+    srcNodeOpt -= 'A';
+    dstNodeOpt -= 'A';
+
+    constexpr float maxFloat = std::numeric_limits<float>::max();
+    // Create routing weight matrix for 10 nodes and initialize weights to infinity (disconnected)
+    ns3::SymmetricAdjacencyMatrix<float> routeWeights(10, maxFloat);
+
+    /* Let's add the entries of this network topology to the matrix
+     *
+     * Node | Corresponding matrix row
+     *  A   | 0
+     *  B   | 1
+     *  C   | 2
+     *  D   | 3
+     *  E   | 4
+     *  F   | 5
+     *  G   | 6
+     *  H   | 7
+     *  I   | 8
+     *  J   | 9
+     *
+     * A------5-------B-------------14-------C
+     * \               \                   /1|
+     *  \               3                 J  |
+     *   \               \               /1  | 7
+     *    4           E-2-F--4---G--3--H     |
+     *     \       8 /                  \    |
+     *      D--------                    10--I
+     */
+
+    // Distance from nodes to other nodes
+    routeWeights.SetValue(0, 1, 5);  // A-B=5
+    routeWeights.SetValue(1, 2, 14); // B-C=14
+    routeWeights.SetValue(0, 3, 4);  // A-D=4
+    routeWeights.SetValue(1, 5, 3);  // B-F=3
+    routeWeights.SetValue(2, 9, 1);  // C-J=1
+    routeWeights.SetValue(9, 7, 1);  // J-H=1
+    routeWeights.SetValue(2, 8, 7);  // C-I=7
+    routeWeights.SetValue(3, 4, 8);  // D-E=8
+    routeWeights.SetValue(4, 5, 2);  // E-F=2
+    routeWeights.SetValue(5, 6, 4);  // F-G=4
+    routeWeights.SetValue(6, 7, 3);  // G-H=3
+    routeWeights.SetValue(7, 8, 10); // H-I=10
+
+    // Distance from nodes to themselves is zero
+    for (size_t i = 0; i < routeWeights.GetRows(); i++)
+    {
+        routeWeights.SetValue(i, i, 0);
+    }
+
+    std::map<std::pair<int, int>, std::vector<int>> routeMap;
+    // Initialize routes
+    for (size_t i = 0; i < routeWeights.GetRows(); i++)
+    {
+        for (size_t j = 0; j < routeWeights.GetRows(); j++)
+        {
+            if (routeWeights.GetValue(i, j) != maxFloat)
+            {
+                if (i != j)
+                {
+                    routeMap[{i, j}] = {(int)i, (int)j};
+                }
+                else
+                {
+                    routeMap[{i, j}] = {(int)i};
+                }
+            }
+        }
+    }
+    // Compute every single shortest route between the nodes of the graph (represented by the
+    // adjacency matrix) We do this in multiple iterations, until we fill the entire matrix
+    for (size_t bridgeNode = 0; bridgeNode < routeWeights.GetRows(); bridgeNode++)
+    {
+        for (size_t srcNode = 0; srcNode < routeWeights.GetRows(); srcNode++)
+        {
+            for (size_t dstNode = 0; dstNode < routeWeights.GetRows(); dstNode++)
+            {
+                auto weightA = routeWeights.GetValue(srcNode, bridgeNode);
+                auto weightB = routeWeights.GetValue(bridgeNode, dstNode);
+                // If there is a path between A and bridge, plus bridge and B
+                if (std::max(weightA, weightB) == maxFloat)
+                {
+                    continue;
+                }
+                // Check if sum of weights is lower than existing path
+                auto weightAB = routeWeights.GetValue(srcNode, dstNode);
+                if (weightA + weightB < weightAB)
+                {
+                    // If it is, update adjacency matrix with the new weight of the shortest
+                    // path
+                    routeWeights.SetValue(srcNode, dstNode, weightA + weightB);
+
+                    // Retrieve the partial routes A->bridge and bridge->C,
+                    // and assemble the new route A->bridge->C
+                    const auto srcToBridgeRoute = routeMap.at({srcNode, bridgeNode});
+                    const auto bridgeToDstRoute = routeMap.at({bridgeNode, dstNode});
+                    std::vector<int> dst;
+                    dst.insert(dst.end(), srcToBridgeRoute.begin(), srcToBridgeRoute.end());
+                    dst.insert(dst.end(), bridgeToDstRoute.begin() + 1, bridgeToDstRoute.end());
+                    routeMap[{srcNode, dstNode}] = dst;
+
+                    // We also include the reverse path, since the graph is bidirectional
+                    std::vector<int> invDst(dst.rbegin(), dst.rend());
+                    routeMap[{dstNode, srcNode}] = invDst;
+                }
+            }
+        }
+    }
+
+    // Now we can print the shortest route between srcNode and dstNode
+    std::cout << "shortest route between " << (char)(srcNodeOpt + 'A') << " and "
+              << (char)(dstNodeOpt + 'A') << " (length "
+              << routeWeights.GetValue(srcNodeOpt, dstNodeOpt) << "):";
+    auto lastNodeNumber = srcNodeOpt;
+    for (auto nodeNumber : routeMap.at({srcNodeOpt, dstNodeOpt}))
+    {
+        std::cout << "--" << routeWeights.GetValue(lastNodeNumber, nodeNumber) << "-->"
+                  << (char)('A' + nodeNumber);
+        lastNodeNumber = nodeNumber;
+    }
+    std::cout << std::endl;
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/examples/CMakeLists.txt ns-3.44/src/antenna/examples/CMakeLists.txt
--- ns-3.43/src/antenna/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.44/src/antenna/examples/CMakeLists.txt	2025-03-09 16:55:49.343371000 -0700
@@ -0,0 +1,5 @@
+build_lib_example(
+  NAME adjacency-matrix-example
+  SOURCE_FILES adjacency-matrix-example.cc
+  LIBRARIES_TO_LINK ${libantenna}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/angles.cc ns-3.44/src/antenna/model/angles.cc
--- ns-3.43/src/antenna/model/angles.cc	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/angles.cc	2025-03-09 16:55:49.343371000 -0700
@@ -8,7 +8,7 @@
 
 #include "angles.h"
 
-#include <ns3/log.h>
+#include "ns3/log.h"
 
 #include <cmath>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/angles.h ns-3.44/src/antenna/model/angles.h
--- ns-3.43/src/antenna/model/angles.h	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/angles.h	2025-03-09 16:55:49.343371000 -0700
@@ -9,7 +9,7 @@
 #ifndef ANGLES_H
 #define ANGLES_H
 
-#include <ns3/vector.h>
+#include "ns3/vector.h"
 
 #include <vector>
 
@@ -17,66 +17,66 @@
 {
 
 /**
- * \brief converts degrees to radians
+ * @brief converts degrees to radians
  *
- * \param degrees the angle in degrees
- * \return the angle in radians
+ * @param degrees the angle in degrees
+ * @return the angle in radians
  */
 double DegreesToRadians(double degrees);
 
 /**
- * \brief converts degrees to radians
+ * @brief converts degrees to radians
  *
- * \param degrees the angles in degrees
- * \return the angles in radians
+ * @param degrees the angles in degrees
+ * @return the angles in radians
  */
 std::vector<double> DegreesToRadians(const std::vector<double>& degrees);
 
 /**
- * \brief converts radians to degrees
+ * @brief converts radians to degrees
  *
- * \param radians the angle in radians
- * \return the angle in degrees
+ * @param radians the angle in radians
+ * @return the angle in degrees
  */
 double RadiansToDegrees(double radians);
 
 /**
- * \brief converts radians to degrees
+ * @brief converts radians to degrees
  *
- * \param radians the angles in radians
- * \return the angles in degrees
+ * @param radians the angles in radians
+ * @return the angles in degrees
  */
 std::vector<double> RadiansToDegrees(const std::vector<double>& radians);
 
 /**
- * \brief Wrap angle in [0, 360)
+ * @brief Wrap angle in [0, 360)
  *
- * \param a the angle in degrees
- * \return the wrapped angle in degrees
+ * @param a the angle in degrees
+ * @return the wrapped angle in degrees
  */
 double WrapTo360(double a);
 
 /**
- * \brief Wrap angle in [-180, 180)
+ * @brief Wrap angle in [-180, 180)
  *
- * \param a the angle in degrees
- * \return the wrapped angle in degrees
+ * @param a the angle in degrees
+ * @return the wrapped angle in degrees
  */
 double WrapTo180(double a);
 
 /**
- * \brief Wrap angle in [0, 2*M_PI)
+ * @brief Wrap angle in [0, 2*M_PI)
  *
- * \param a the angle in radians
- * \return the wrapped angle in radians
+ * @param a the angle in radians
+ * @return the wrapped angle in radians
  */
 double WrapTo2Pi(double a);
 
 /**
- * \brief Wrap angle in [-M_PI, M_PI)
+ * @brief Wrap angle in [-M_PI, M_PI)
  *
- * \param a the angle in radians
- * \return the wrapped angle in radians
+ * @param a the angle in radians
+ * @return the wrapped angle in radians
  */
 double WrapToPi(double a);
 
@@ -111,8 +111,8 @@
      * Inclination must be in [0, M_PI], while azimuth is
      * automatically normalized in [-M_PI, M_PI)
      *
-     * \param azimuth the azimuth angle in radians
-     * \param inclination the inclination angle in radians
+     * @param azimuth the azimuth angle in radians
+     * @param inclination the inclination angle in radians
      */
     Angles(double azimuth, double inclination);
 
@@ -122,7 +122,7 @@
      * Note: azimuth and inclination angles for a zero-length vector are not defined
      * and are thus initialized to NAN
      *
-     * \param v the 3D vector in cartesian coordinates
+     * @param v the 3D vector in cartesian coordinates
      *
      */
     Angles(Vector v);
@@ -131,8 +131,8 @@
      * This constructor initializes an Angles instance with the angles
      * of the spherical coordinates of point v respect to point o
      *
-     * \param v the point (in cartesian coordinates) for which the angles are determined
-     * \param o the origin (in cartesian coordinates) of the spherical coordinate system
+     * @param v the point (in cartesian coordinates) for which the angles are determined
+     * @param o the origin (in cartesian coordinates) of the spherical coordinate system
      *
      */
     Angles(Vector v, Vector o);
@@ -140,46 +140,46 @@
     /**
      * Setter for azimuth angle
      *
-     * \param azimuth angle in radians
+     * @param azimuth angle in radians
      */
     void SetAzimuth(double azimuth);
 
     /**
      * Setter for inclination angle
      *
-     * \param inclination angle in radians. Must be in [0, M_PI]
+     * @param inclination angle in radians. Must be in [0, M_PI]
      */
     void SetInclination(double inclination);
 
     /**
      * Getter for azimuth angle
      *
-     * \return azimuth angle in radians
+     * @return azimuth angle in radians
      */
     double GetAzimuth() const;
 
     /**
      * Getter for inclination angle
      *
-     * \return inclination angle in radians
+     * @return inclination angle in radians
      */
     double GetInclination() const;
 
     // friend methods
     /**
-     * \brief Stream insertion operator.
+     * @brief Stream insertion operator.
      *
-     * \param [in] os The reference to the output stream.
-     * \param [in] a The angle.
-     * \returns The reference to the output stream.
+     * @param [in] os The reference to the output stream.
+     * @param [in] a The angle.
+     * @returns The reference to the output stream.
      */
     friend std::ostream& operator<<(std::ostream& os, const Angles& a);
     /**
-     * \brief Stream extraction operator.
+     * @brief Stream extraction operator.
      *
-     * \param [in] is The reference to the input stream.
-     * \param [out] a The angle.
-     * \returns The reference to the input stream.
+     * @param [in] is The reference to the input stream.
+     * @param [out] a The angle.
+     * @returns The reference to the input stream.
      */
     friend std::istream& operator>>(std::istream& is, Angles& a);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/antenna-model.cc ns-3.44/src/antenna/model/antenna-model.cc
--- ns-3.43/src/antenna/model/antenna-model.cc	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/antenna-model.cc	2025-03-09 16:55:49.343371000 -0700
@@ -8,7 +8,7 @@
 
 #include "antenna-model.h"
 
-#include <ns3/log.h>
+#include "ns3/log.h"
 
 #include <cmath>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/antenna-model.h ns-3.44/src/antenna/model/antenna-model.h
--- ns-3.43/src/antenna/model/antenna-model.h	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/antenna-model.h	2025-03-09 16:55:49.343371000 -0700
@@ -11,27 +11,27 @@
 
 #include "angles.h"
 
-#include <ns3/object.h>
+#include "ns3/object.h"
 
 namespace ns3
 {
 
 /**
- * \defgroup antenna Antenna module
- * \brief This module contains several antenna
+ * @defgroup antenna Antenna module
+ * @brief This module contains several antenna
  * radiation pattern models.
  */
 
 /**
- * \ingroup antenna
- * \ingroup tests
- * \defgroup antenna-tests Antenna module tests
+ * @ingroup antenna
+ * @ingroup tests
+ * @defgroup antenna-tests Antenna module tests
  */
 
 /**
- * \ingroup antenna
+ * @ingroup antenna
  *
- * \brief interface for antenna radiation pattern models
+ * @brief interface for antenna radiation pattern models
  *
  * This class provides an interface for the definition of antenna
  * radiation pattern models. This interface is based on the use of
@@ -47,18 +47,18 @@
     ~AntennaModel() override;
 
     /**
-     * \brief Get the type ID.
-     * \return The object TypeId.
+     * @brief Get the type ID.
+     * @return The object TypeId.
      */
     static TypeId GetTypeId();
 
     /**
      * this method is expected to be re-implemented by each antenna model
      *
-     * \param a the spherical angles at which the radiation pattern should
+     * @param a the spherical angles at which the radiation pattern should
      * be evaluated
      *
-     * \return the power gain in dBi of the antenna radiation pattern at
+     * @return the power gain in dBi of the antenna radiation pattern at
      * the specified angles; dBi means dB with respect to the gain of an
      * isotropic radiator. Since a power gain is used, the efficiency of
      * the antenna is expected to be included in the gain value.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/circular-aperture-antenna-model.cc ns-3.44/src/antenna/model/circular-aperture-antenna-model.cc
--- ns-3.43/src/antenna/model/circular-aperture-antenna-model.cc	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/circular-aperture-antenna-model.cc	2025-03-09 16:55:49.343371000 -0700
@@ -16,14 +16,15 @@
 
 #include "antenna-model.h"
 
-#include <ns3/double.h>
-#include <ns3/log.h>
+#include "ns3/boolean.h"
+#include "ns3/double.h"
+#include "ns3/log.h"
 
 #include <math.h>
 
 /**
- * \file
- * \ingroup antenna
+ * @file
+ * @ingroup antenna
  * Class CircularApertureAntennaModel implementation.
  */
 
@@ -65,7 +66,12 @@
                           "The maximum gain value in dB of the antenna",
                           DoubleValue(1),
                           MakeDoubleAccessor(&CircularApertureAntennaModel::SetMaxGain),
-                          MakeDoubleChecker<double>(0.0));
+                          MakeDoubleChecker<double>(0.0))
+            .AddAttribute("ForceGainBounds",
+                          "Force GetGainDb to [AntennaMinGainDb, AntennaMaxGainDb] range",
+                          BooleanValue(true),
+                          MakeBooleanAccessor(&CircularApertureAntennaModel::m_forceGainBounds),
+                          MakeBooleanChecker());
     return tid;
 }
 
@@ -174,6 +180,10 @@
         gain = std::cyl_bessel_j(1, kasintheta) / kasintheta;
 #endif
         gain = 10 * log10(4 * gain * gain) + m_maxGain;
+        if (m_forceGainBounds)
+        {
+            gain = std::min(std::max(gain, m_minGain), m_maxGain);
+        }
     }
 
     return gain;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/circular-aperture-antenna-model.h ns-3.44/src/antenna/model/circular-aperture-antenna-model.h
--- ns-3.43/src/antenna/model/circular-aperture-antenna-model.h	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/circular-aperture-antenna-model.h	2025-03-09 16:55:49.343371000 -0700
@@ -11,18 +11,18 @@
 
 #include "antenna-model.h"
 
-#include <ns3/object.h>
+#include "ns3/object.h"
 
 /**
- * \file
- * \ingroup antenna
+ * @file
+ * @ingroup antenna
  * Class CircularApertureAntennaModel declaration
  */
 
 namespace ns3
 {
 /**
- * \brief Circular Aperture Antenna Model
+ * @brief Circular Aperture Antenna Model
  *
  * This class implements the circular aperture antenna as described in 3GPP 38.811 6.4.1
  * https://www.3gpp.org/ftp/Specs/archive/38_series/38.811 without the cosine approximation, thanks
@@ -41,79 +41,79 @@
 
     /**
      * Register this type.
-     * \return The object TypeId.
+     * @return The object TypeId.
      */
     static TypeId GetTypeId();
 
     /**
-     * \brief Set the antenna aperture radius
+     * @brief Set the antenna aperture radius
      *
      * Sets the antenna operating frequency, asserting that
      * the provided value is within the acceptable range [0, +inf[.
      *
-     * \param aMeter the strictly positive antenna radius in meters
+     * @param aMeter the strictly positive antenna radius in meters
      */
     void SetApertureRadius(double aMeter);
 
     /**
-     * \brief Return the antenna aperture radius
+     * @brief Return the antenna aperture radius
      *
-     * \return the antenna radius in meters
+     * @return the antenna radius in meters
      */
     double GetApertureRadius() const;
 
     /**
-     * \brief Set the antenna operating frequency.
+     * @brief Set the antenna operating frequency.
      *
      * Sets the antenna operating frequency, asserting that
      * the provided value is within the acceptable range [0, +inf[.
      *
-     * \param freqHz the strictly positive antenna operating frequency, in Hz
+     * @param freqHz the strictly positive antenna operating frequency, in Hz
      */
     void SetOperatingFrequency(double freqHz);
 
     /**
-     * \brief Return the antenna operating frequency
+     * @brief Return the antenna operating frequency
      *
-     * \return the antenna operating frequency, in Hz
+     * @return the antenna operating frequency, in Hz
      */
     double GetOperatingFrequency() const;
 
     /**
-     * \brief Set the antenna max gain
+     * @brief Set the antenna max gain
      *
-     * \param gainDb the antenna max gain in dB
+     * @param gainDb the antenna max gain in dB
      */
     void SetMaxGain(double gainDb);
 
     /**
-     * \brief Return the antenna max gain
+     * @brief Return the antenna max gain
      *
-     * \return the antenna max gain in dB
+     * @return the antenna max gain in dB
      */
     double GetMaxGain() const;
 
     /**
-     * \brief Set the antenna min gain
+     * @brief Set the antenna min gain
      *
-     * \param gainDb the antenna min gain in dB
+     * @param gainDb the antenna min gain in dB
      */
     void SetMinGain(double gainDb);
 
     /**
-     * \brief Return the antenna min gain
+     * @brief Return the antenna min gain
      *
-     * \return the antenna min gain in dB
+     * @return the antenna min gain in dB
      */
     double GetMinGain() const;
 
     /**
-     * \brief Get the gain in dB, using Bessel equation of first kind and first order.
+     * @brief Get the gain in dB, using Bessel equation of first kind and first order.
      *
-     * \param a the angle at which the gain need to be calculated with respect to the antenna
+     * @param a the angle at which the gain need to be calculated with respect to the antenna
      * bore sight
      *
-     * \return the antenna gain at the specified Angles a
+     * @return the antenna gain at the specified Angles a
      */
     double GetGainDb(Angles a) override;
 
@@ -122,6 +122,7 @@
     double m_operatingFrequencyHz; //!< antenna operating frequency in Hz
     double m_maxGain;              //!< antenna gain in dB towards the main orientation
     double m_minGain;              //!< antenna min gain in dB
+    bool m_forceGainBounds;        //!< enforce maximum and minimum gains (disabled for testing)
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/antenna/model/cosine-antenna-model.cc ns-3.44/src/antenna/model/cosine-antenna-model.cc
--- ns-3.43/src/antenna/model/cosine-antenna-model.cc	2024-10-09 16:41:09.844655800 -0700
+++ ns-3.44/src/antenna/model/cosine-antenna-model.cc	2025-03-09 16:55:49.343371000 -0700
@@ -10,8 +10,8 @@
 
 #include "antenna-model.h"
 
-#include <ns3/double.h>
-#include <ns3/log.h>
+#include "ns3/double.h"
+#include "ns3/log.h"
 
 #include <cmath>
 
